<?php
/* inspired from Autoload.php from version 1.2 */

require_once 'File/Iterator/Autoload.php';
require_once 'PHP/Token/Stream/Autoload.php';
require_once 'Text/Template/Autoload.php';
require_once 'SebastianBergmann/Environment/autoload.php';
require_once 'SebastianBergmann/Version/autoload.php';

spl_autoload_register(
  function ($class)
  {
      static $classes = NULL;
      static $path = NULL;

      if ($classes === NULL) {
          $classes = array(
            'php_codecoverage' => '/CodeCoverage.php',
                'php_codecoverage_driver' => '/CodeCoverage/Driver.php',
                'php_codecoverage_driver_hhvm' => '/CodeCoverage/Driver/HHVM.php',
                'php_codecoverage_driver_xdebug' => '/CodeCoverage/Driver/Xdebug.php',
                'php_codecoverage_exception' => '/CodeCoverage/Exception.php',
                'php_codecoverage_exception_unintentionallycoveredcode' => '/CodeCoverage/Exception/UnintentionallyCoveredCode.php',
                'php_codecoverage_filter' => '/CodeCoverage/Filter.php',
                'php_codecoverage_report_clover' => '/CodeCoverage/Report/Clover.php',
                'php_codecoverage_report_crap4j' => '/CodeCoverage/Report/Crap4j.php',
                'php_codecoverage_report_factory' => '/CodeCoverage/Report/Factory.php',
                'php_codecoverage_report_html' => '/CodeCoverage/Report/HTML.php',
                'php_codecoverage_report_html_renderer' => '/CodeCoverage/Report/HTML/Renderer.php',
                'php_codecoverage_report_html_renderer_dashboard' => '/CodeCoverage/Report/HTML/Renderer/Dashboard.php',
                'php_codecoverage_report_html_renderer_directory' => '/CodeCoverage/Report/HTML/Renderer/Directory.php',
                'php_codecoverage_report_html_renderer_file' => '/CodeCoverage/Report/HTML/Renderer/File.php',
                'php_codecoverage_report_node' => '/CodeCoverage/Report/Node.php',
                'php_codecoverage_report_node_directory' => '/CodeCoverage/Report/Node/Directory.php',
                'php_codecoverage_report_node_file' => '/CodeCoverage/Report/Node/File.php',
                'php_codecoverage_report_node_iterator' => '/CodeCoverage/Report/Node/Iterator.php',
                'php_codecoverage_report_php' => '/CodeCoverage/Report/PHP.php',
                'php_codecoverage_report_text' => '/CodeCoverage/Report/Text.php',
                'php_codecoverage_report_xml' => '/CodeCoverage/Report/XML.php',
                'php_codecoverage_report_xml_directory' => '/CodeCoverage/Report/XML/Directory.php',
                'php_codecoverage_report_xml_file' => '/CodeCoverage/Report/XML/File.php',
                'php_codecoverage_report_xml_file_coverage' => '/CodeCoverage/Report/XML/File/Coverage.php',
                'php_codecoverage_report_xml_file_method' => '/CodeCoverage/Report/XML/File/Method.php',
                'php_codecoverage_report_xml_file_report' => '/CodeCoverage/Report/XML/File/Report.php',
                'php_codecoverage_report_xml_file_unit' => '/CodeCoverage/Report/XML/File/Unit.php',
                'php_codecoverage_report_xml_node' => '/CodeCoverage/Report/XML/Node.php',
                'php_codecoverage_report_xml_project' => '/CodeCoverage/Report/XML/Project.php',
                'php_codecoverage_report_xml_tests' => '/CodeCoverage/Report/XML/Tests.php',
                'php_codecoverage_report_xml_totals' => '/CodeCoverage/Report/XML/Totals.php',
                'php_codecoverage_util' => '/CodeCoverage/Util.php',
                'php_codecoverage_util_invalidargumenthelper' => '/CodeCoverage/Util/InvalidArgumentHelper.php'
          );

          $path = dirname(dirname(__FILE__));
      }

      $cn = strtolower($class);

      if (isset($classes[$cn])) {
          require $path . $classes[$cn];
      }
  }
);
